//
//  File: client3.java
//

import java.sql.*;

public class client3
{
  public static void main( String args[] )
  {
    Class driverClass = loadDriver( "org.postgresql.Driver" );

    if( driverClass == null )
      return;

    if( args.length != 1 )
    {
      System.err.println( "usage: java client3 <url>" );
      return;
    }

    Connection con = connectURL( args[0] );

    if( con != null )
    {
      ResultSet result = execQuery( con, "SELECT * FROM tapes;" );
	  
      if( result != null )
	printResults( result );
    }
  }

  static Class loadDriver( String driverName )
  {
    try 
    { 
      return( Class.forName( driverName ));
    }
    catch( ClassNotFoundException e )
    {
      System.err.println( "Can't load driver - " + e.getMessage());
      return( null );
    }
  }

  static Connection connectURL( String URL )
  {
    try
    {
      return( DriverManager.getConnection( URL ));
    }
    catch( SQLException e )
    {
      System.err.println( "Can't connect - " + e.getMessage());
      return( null );
    }
  }

  static ResultSet execQuery( Connection con, String query )
  {
    try
    {
      Statement stmt = con.createStatement();

      System.out.println( query );

      return( stmt.executeQuery( query ));
    }
    catch( SQLException e )
    {
      System.err.println( "Query failed - " + e.getMessage());
      return( null );
    }
  }

  static void printResults( ResultSet res )
  {
    System.out.println( " tape_id | title" );
    System.out.println( "---------+------------------------------" );

    try
    {
      while( res.next())
      {
        System.out.print( res.getString( 1 ));
	System.out.print( " | ");
	System.out.print( res.getString( 2 ));
	System.out.println( "" );
      }
    }
    catch( SQLException e )
    {
      System.err.println( "Fetch failed: " + e.getMessage());
    }
  }
}
