/* client3c.c */

#include <stdio.h>
#include <libpq-fe.h>
#include <libpgeasy.h>

int main( int argc, char * argv[] )
{
  int       id;             /* customer_id column   */
  char      name[80+1];     /* customer_name column */
  float     balance;        /* balance column       */
  int       nulls[3];       /* NULL indicators      */
  PGconn *  connection;

  connection = connectdb( argv[1] ? argv[1] : "" );

  on_error_stop( );

  doquery( "BEGIN WORK" );

  doquery( "DECLARE customer_list BINARY CURSOR FOR "
           "SELECT "
             "id, customer_name, balance::float4 "
           "FROM customers" );
  
  doquery( "FETCH ALL FROM customer_list" );
  
  while( fetchwithnulls( &id,      &nulls[0], 
                         &name[0], &nulls[1], 
                         &balance, &nulls[2] ) 
         != END_OF_TUPLES )
  {
    if( nulls[2] )
      printf( "%4d: %-40s   NULL\n", id, name );
    else
      printf( "%4d: %-40s %6.2f\n", id, name, balance );
  }

  doquery( "COMMIT" );

  disconnectdb();

}
