#!/usr/bin/perl -W
#
#  Filename: client3c.pl
#
use strict;
use DBI;

my $dbh = DBI->connect("dbi:Pg:", undef, undef, {PrintError => 1})
  or die "Can't connect to PostgreSQL: $DBI::errstr ($DBI::err)\n";

$dbh->do( "SET TRANSFORM_NULL_EQUALS TO ON" );

my $sth = $dbh->prepare( $ARGV[0] );

if( defined( $sth )) {

    get_params( $sth );

    if( $sth->execute()) {
	$sth->dump_results();
    }
}

$dbh->disconnect();

#
#  subroutine: get_params( $sth )
#
sub get_params
{
    my $sth             = shift;
    my $parameter_count = $sth->{NUM_OF_PARAMS};
    my $line            = undef;

    for( my $i = 1; $i <= $parameter_count; $i++ ) {
	print( "Enter value for parameter $i: " );

	chomp( $line = <STDIN> );
	
	if( length( $line )) {
	    $sth->bind_param( $i, $line );
	}
	else {
	    $sth->bind_param( $i, undef );
	}
    }
}
