#!/usr/bin/perl
#
#  Filename: client3d.pl
#
use strict;
use DBI;

my $dbh = DBI->connect("dbi:Pg:", undef, undef, {PrintError => 1})
  or die "Can't connect to PostgreSQL: $DBI::errstr ($DBI::err)\n";

my $sth = $dbh->prepare( $ARGV[0] );

if( defined( $sth )) {
    if( $sth->execute()) {
	print_results( $sth );
    }
}

$dbh->disconnect();

#
#  subroutine: print_results( $sth )
#
sub print_results
{
    my $sth = shift;

    while( my $vals = $sth->fetchrow_arrayref()) {
	foreach my $val ( @$vals ) {
	    print( $val . "\t" );
	}
	print( "\n" );
    }
}
