/* 
** Filename: filesize.c
*/

#include "postgres.h"
#include "fmgr.h"
#include <sys/stat.h>

PG_FUNCTION_INFO_V1(filesize);

Datum filesize(PG_FUNCTION_ARGS)
{
    text * fileNameText = PG_GETARG_TEXT_P(0);
    size_t fileNameLen  = VARSIZE( fileNameText ) - VARHDRSZ;
    char * fileName     = (char *)palloc( fileNameLen + 1 );
    struct stat statBuf;

    memcpy( fileName, VARDATA( fileNameText ), fileNameLen );
    fileName[fileNameLen] = '\0';

    if( stat(fileName, &statBuf) == 0 && S_ISREG(statBuf.st_mode))
    {
	pfree( fileName );

	PG_RETURN_INT32((int32)statBuf.st_size );
    }
    else
    {
	pfree( fileName );

	PG_RETURN_NULL();
    }
}


