<?php 

  // Filename: my_table_a.inc

  class my_table 
  { 
    var $result;
    var $columns;

    function my_table( $db_handle, $command )
    {
      $this->result  = @pg_query( $db_handle, $command );
      
      if( $this->result == FALSE )
      {
	 echo pg_last_error( $db_handle );
      }
      else
      {
        $this->columns = pg_num_fields( $this->result );

	if( $this->columns == 0 )
	{
	    echo $command;
	    echo "<BR>"; 
	    echo pg_affected_rows( $this->result );
	    echo " row(s) affected";
	    
	    if( pg_last_oid( $this->result ) != 0 )
		echo ", OID =  ". pg_last_oid( $this->result );
	}
	else
	{
	    $row_count     = pg_num_rows( $this->result );

	    $this->start_table( $command );

	    for( $row = 0; $row < $row_count; $row++ )
	      $this->append_row( $this->result, $row );
	}
      }
    }

    function start_table( $command )
    {
      echo '<TABLE CELLPADDING="2" CELLSPACING="0" BORDER=1>';

      for( $col = 0; $col < $this->columns; $col++ )
      {
	echo "  <TH>";
	echo pg_field_name( $this->result, $col );
	echo "</TH>\n";
      }
      echo "\n";
    }

    function finish() 
    { 
      print( "</TABLE>\n" ); 

      if( $this->result )
	pg_free_result( $this->result );
    } 

    function append_row( $result, $row )
    {
      echo( "<TR>\n" );

      for( $col = 0; $col < $this->columns; $col++ )
      {
	echo "  <TD>";

	if( pg_field_is_null( $result, $row, $col ) == 1 )
	  echo "&nbsp";
	else
	  echo pg_result( $result, $row, $col );
	echo "</TD>\n";
      }

      echo( "</TR>\n" );
    }
  }

?>
