/* persist-tran.cpp */
#include <libpq++.h>
#include <iostream.h>

class Transaction
{
public:
  
  Transaction( PgDatabase & db );
  ~Transaction();

  PgDatabase & db;
};

Transaction::Transaction( PgDatabase & myDb )
  : db( myDb )
{
  if( db.Status() == CONNECTION_OK )
  {
    (void)db.Exec( "BEGIN" );
  }
}

Transaction::~Transaction()
{
  if( db.Status() == CONNECTION_OK )
  {
    (void)db.Exec( "COMMIT" );
  }
}

void do_transaction( PgDatabase & db )
{
  Transaction  tran( db );

  tran.db.Exec( "update employee set salary = salary * 1.10" );

}

int main( int argc, char * argv[] )
{
  PgDatabase db( argv[1] ? argv[1]: "" );

  if( db.Status() != CONNECTION_OK )
  {
    cout << "Connection failed" << endl << db.ErrorMessage() << endl;
  }
  else
  {
    do_transaction( db );
  }
}
