drop table customers;
drop table tapes;
drop table rentals;
drop table returns;
drop table history;
drop table dtypes;
drop table dates;

CREATE TABLE "customers" (
	"id" integer unique not null,
	"customer_name" character varying(50) not null,
	"phone" character(8) null,
	"birth_date" date null,
	"balance" decimal(7,2)
);


CREATE TABLE "tapes" (
	"tape_id" character(8) not null,
	"title" character varying(80) not null
);


CREATE TABLE "rentals" (
	"tape_id" character(8) not null,
	"rental_date" date not null,
	"customer_id" integer not null
);


CREATE TABLE "returns" (
	"return_date" date,
	"tape_id" character(8)
);

CREATE TABLE "history" (
	"customer_id" integer,
	"tape_id" character(8),
	"rental_date" date,
	"return_date" date
);

COPY "customers"  FROM stdin;
1	Jones, Henry	555-1212	1970-10-10	0.00
2	Rubin, William	555-2211	1972-07-10	15.00
3	Panky, Henry	555-1221	1968-01-21	0.00
4	Wonderland, Alice N.	555-1122	1969-03-05	3.00
\.

COPY "tapes"  FROM stdin;
AB-12345	The Godfather
AB-67472	The Godfather
MC-68873	Casablanca
OW-41221	Citizen Kane
AH-54706	Rear Window
\.

COPY "rentals"  FROM stdin;
AB-12345	2001-11-25	1
AB-67472	2001-11-25	3
OW-41221	2001-11-25	1
MC-68873	2001-11-20	3
\.

COPY "returns"  FROM stdin;
2001-11-26	AB-12345
2001-12-23	OW-41221
\.


CREATE TABLE "dtypes" (
	"dtype_integer"		integer,
	"dtype_smallint"	smallint,
	"dtype_bigint"		bigint,
	"dtype_decimal_9_2"	decimal(9,2),
	"dtype_numeric_9_2" numeric(9,2),
	"dtype_real"		real,
	"dtype_double"		double precision,
	"dtype_money"		money,
	"dtype_boolean"		boolean
);

COPY "dtypes"  FROM stdin;
1234	1234	1234	1234	1234	1234	1234	1234	TRUE
2345	2345	2345	2345	2345	2345	2345	2345	FALSE
-1234	-1234	-1234	-1234	-1234	-1234	-1234	-1234	TRUE
\.

CREATE TABLE "dates" (
	"dates_date"		date,
	"dates_timestamp"	timestamp,
	"dates_time"		time,
	"dates_interval"	interval
);

COPY "dates" FROM stdin;
06-DEC-2001	06-DEC-2001 01:23:45.678	01:23:45.678	-2 days 
30-OCT-1962	30-OCT-1962 01:23:45.678	01:23:45.678	10 days
12-05-2001	12-DEC-2001 13:12:34.567	13:12:34.567	3650 days
\.
